## nghttp3 0~20201019

=== CMakeLists.txt ===
# nghttp3
#
# Copyright (c) 2019 nghttp3 contributors
# Copyright (c) 2016 ngtcp2 contributors
# Copyright (c) 2012 nghttp2 contributors
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

cmake_minimum_required(VERSION 3.1)
# XXX using 0.1.90 instead of 0.1.0-DEV
project(nghttp3 VERSION 0.1.90)

# See versioning rule:
#  http://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
set(LT_CURRENT  0)
set(LT_REVISION 0)
set(LT_AGE      0)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(Version)

math(EXPR LT_SOVERSION "${LT_CURRENT} - ${LT_AGE}")
set(LT_VERSION "${LT_SOVERSION}.${LT_AGE}.${LT_REVISION}")
set(PACKAGE_VERSION     "${PROJECT_VERSION}")
HexVersion(PACKAGE_VERSION_NUM ${PROJECT_VERSION_MAJOR} ${PROJECT_VERSION_MINOR} ${PROJECT_VERSION_PATCH})

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the build type" FORCE)

  # Include "None" as option to disable any additional (optimization) flags,
  # relying on just CMAKE_C_FLAGS and CMAKE_CXX_FLAGS (which are empty by
  # default). These strings are presented in cmake-gui.
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "None" "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

include(GNUInstallDirs)

include(CMakeOptions.txt)

# Do not disable assertions based on CMAKE_BUILD_TYPE.
foreach(_build_type "Release" "MinSizeRel" "RelWithDebInfo")
  foreach(_lang C CXX)
    string(TOUPPER "CMAKE_${_lang}_FLAGS_${_build_type}" _var)
    string(REGEX REPLACE "(^| )[/-]D *NDEBUG($| )" "" ${_var} "${${_var}}")
  endforeach()
endforeach()

find_package(CUnit 2.1)
enable_testing()
set(HAVE_CUNIT      ${CUNIT_FOUND})
if(HAVE_CUNIT)
  add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
endif()

# Checks for header files.
include(CheckIncludeFile)
check_include_file("arpa/inet.h"   HAVE_ARPA_INET_H)
check_include_file("stddef.h"      HAVE_STDDEF_H)
check_include_file("stdint.h"      HAVE_STDINT_H)
check_include_file("stdlib.h"      HAVE_STDLIB_H)
check_include_file("string.h"      HAVE_STRING_H)
check_include_file("unistd.h"      HAVE_UNISTD_H)
check_include_file("sys/endian.h"  HAVE_SYS_ENDIAN_H)
check_include_file("endian.h"      HAVE_ENDIAN_H)
check_include_file("byteswap.h"    HAVE_BYTESWAP_H)

include(CheckTypeSize)
# Checks for typedefs, structures, and compiler characteristics.
# AC_TYPE_SIZE_T
check_type_size("ssize_t" SIZEOF_SSIZE_T)
if(SIZEOF_SSIZE_T STREQUAL "")
  # ssize_t is a signed type in POSIX storing at least -1.
  # Set it to a pointer-size int.
  set(ssize_t ptrdiff_t)
endif()

# Checks for symbols.
include(CheckSymbolExists)
if(HAVE_ENDIAN_H)
  check_symbol_exists(be64toh "endian.h" HAVE_BE64TOH)
endif()
if(HAVE_SYS_ENDIAN_H)
  check_symbol_exists(be64toh "sys/endian.h" HAVE_BE64TOH)
endif()

check_symbol_exists(bswap_64 "byteswap.h" HAVE_BSWAP_64)

include(ExtractValidFlags)
set(WARNCFLAGS)
set(WARNCXXFLAGS)
if(CMAKE_C_COMPILER_ID MATCHES "MSVC")
  if(ENABLE_WERROR)
    set(WARNCFLAGS    /WX)
    set(WARNCXXFLAGS  /WX)
  endif()
else()
  if(ENABLE_WERROR)
    extract_valid_c_flags(WARNCFLAGS    -Werror)
    extract_valid_c_flags(WARNCXXFLAGS  -Werror)
  endif()

  # For C compiler
  extract_valid_c_flags(WARNCFLAGS
    -Wall
    -Wextra
    -Wmissing-prototypes
    -Wstrict-prototypes
    -Wmissing-declarations
    -Wpointer-arith
    -Wdeclaration-after-statement
    -Wformat-security
    -Wwrite-strings
    -Wshadow
    -Winline
    -Wnested-externs
    -Wfloat-equal
    -Wundef
    -Wendif-labels
    -Wempty-body
    -Wcast-align
    -Wclobbered
    -Wvla
    -Wpragmas
    -Wunreachable-code
    -Waddress
    -Wattributes
    -Wdiv-by-zero
    -Wshorten-64-to-32

    -Wconversion
    -Wextended-offsetof
    -Wformat-nonliteral
    -Wlanguage-extension-token
    -Wmissing-field-initializers
    -Wmissing-noreturn
    -Wmissing-variable-declarations
    # Not used because we cannot change public structs
    # -Wpadded
    -Wsign-conversion
    # Not used because this basically disallows default case
    # -Wswitch-enum
    -Wunreachable-code-break
    -Wunused-macros
    -Wunused-parameter
    -Wredundant-decls
    # Only work with Clang for the moment
    -Wheader-guard
    -Wsometimes-uninitialized

    # Only work with gcc7 for the moment
    -Wduplicated-branches
    # This is required because we pass format string as "const char*.
    -Wno-format-nonliteral
  )

  extract_valid_cxx_flags(WARNCXXFLAGS
    # For C++ compiler
    -Wall
    -Wformat-security
    -Wsometimes-uninitialized
    # Disable noexcept-type warning of g++-7.  This is not harmful as
    # long as all source files are compiled with the same compiler.
    -Wno-noexcept-type
  )

  if(ENABLE_ASAN)
    include(CMakePushCheckState)
    cmake_push_check_state()
    set(CMAKE_REQUIRED_LIBRARIES "-fsanitize=address")
    check_c_compiler_flag(-fsanitize=address C__fsanitize_address_VALID)
    check_cxx_compiler_flag(-fsanitize=address CXX__fsanitize_address_VALID)
    cmake_pop_check_state()
    if(NOT C__fsanitize_address_VALID OR NOT CXX__fsanitize_address_VALID)
      message(WARNING "ENABLE_ASAN was requested, but not supported!")
    else()
      set(CMAKE_C_FLAGS "-fsanitize=address ${CMAKE_C_FLAGS}")
      set(CMAKE_CXX_FLAGS "-fsanitize=address ${CMAKE_CXX_FLAGS}")
    endif()
  endif()
endif()

if(ENABLE_DEBUG)
  set(DEBUGBUILD 1)
endif()

if(ENABLE_LIB_ONLY)
  set(ENABLE_EXAMPLES 0)
else()
  set(ENABLE_EXAMPLES 1)
endif()

add_definitions(-DHAVE_CONFIG_H)
configure_file(cmakeconfig.h.in config.h)
# autotools-compatible names
# Sphinx expects relative paths in the .rst files. Use the fact that the files
# below are all one directory level deep.
file(RELATIVE_PATH top_srcdir   "${CMAKE_CURRENT_BINARY_DIR}/dir" "${CMAKE_CURRENT_SOURCE_DIR}")
file(RELATIVE_PATH top_builddir "${CMAKE_CURRENT_BINARY_DIR}/dir" "${CMAKE_CURRENT_BINARY_DIR}")
set(abs_top_srcdir  "${CMAKE_CURRENT_SOURCE_DIR}")
set(abs_top_builddir "${CMAKE_CURRENT_BINARY_DIR}")
# libnghttp3.pc (pkg-config file)
set(prefix          "${CMAKE_INSTALL_PREFIX}")
set(exec_prefix     "${CMAKE_INSTALL_PREFIX}")
set(libdir          "${CMAKE_INSTALL_FULL_LIBDIR}")
set(includedir      "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
set(VERSION         "${PACKAGE_VERSION}")
# For init scripts and systemd service file (in contrib/)
set(bindir          "${CMAKE_INSTALL_FULL_BINDIR}")
set(sbindir         "${CMAKE_INSTALL_FULL_SBINDIR}")
foreach(name
  lib/libnghttp3.pc
  lib/includes/nghttp3/version.h
)
  configure_file("${name}.in" "${name}" @ONLY)
endforeach()

include_directories(
  "${CMAKE_CURRENT_BINARY_DIR}" # for config.h
)
# For use in src/CMakeLists.txt
set(PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/${CMAKE_PROJECT_NAME}")

install(FILES README.rst DESTINATION "${CMAKE_INSTALL_DOCDIR}")

add_subdirectory(lib)
add_subdirectory(tests)
add_subdirectory(examples)


string(TOUPPER "${CMAKE_BUILD_TYPE}" _build_type)
message(STATUS "summary of build options:

    Package version: ${VERSION}
    Library version: ${LT_CURRENT}:${LT_REVISION}:${LT_AGE}
    Install prefix:  ${CMAKE_INSTALL_PREFIX}
    Target system:   ${CMAKE_SYSTEM_NAME}
    Compiler:
      Build type:     ${CMAKE_BUILD_TYPE}
      C compiler:     ${CMAKE_C_COMPILER}
      CFLAGS:         ${CMAKE_C_FLAGS_${_build_type}} ${CMAKE_C_FLAGS}
      C++ compiler:   ${CMAKE_CXX_COMPILER}
      CXXFLAGS:       ${CMAKE_CXX_FLAGS_${_build_type}} ${CMAKE_CXX_FLAGS}
      WARNCFLAGS:     ${WARNCFLAGS}
      WARNCXXFLAGS:   ${WARNCXXFLAGS}
    Test:
      CUnit:          ${HAVE_CUNIT} (LIBS='${CUNIT_LIBRARIES}')
    Library only:     ${ENABLE_LIB_ONLY}
    Examples:         ${ENABLE_EXAMPLES}
")

=== lib/CMakeLists.txt ===
# nghttp3
#
# Copyright (c) 2019 nghttp3
# Copyright (c) 2016 ngtcp2
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

add_subdirectory(includes)

include_directories(
  "${CMAKE_CURRENT_SOURCE_DIR}/includes"
  "${CMAKE_CURRENT_BINARY_DIR}/includes"
)

add_definitions(-DBUILDING_NGHTTP3)

set(nghttp3_SOURCES
  nghttp3_rcbuf.c
  nghttp3_mem.c
  nghttp3_str.c
  nghttp3_conv.c
  nghttp3_buf.c
  nghttp3_ringbuf.c
  nghttp3_pq.c
  nghttp3_map.c
  nghttp3_ksl.c
  nghttp3_qpack.c
  nghttp3_qpack_huffman.c
  nghttp3_qpack_huffman_data.c
  nghttp3_err.c
  nghttp3_debug.c
  nghttp3_conn.c
  nghttp3_stream.c
  nghttp3_frame.c
  nghttp3_tnode.c
  nghttp3_vec.c
  nghttp3_gaptr.c
  nghttp3_idtr.c
  nghttp3_range.c
  nghttp3_http.c
  nghttp3_version.c
)

# Public shared library
add_library(nghttp3 SHARED ${nghttp3_SOURCES})
set_target_properties(nghttp3 PROPERTIES
  COMPILE_FLAGS "${WARNCFLAGS}"
  VERSION ${LT_VERSION} SOVERSION ${LT_SOVERSION}
  C_VISIBILITY_PRESET hidden
)

if(HAVE_CUNIT OR ENABLE_STATIC_LIB)
  # Static library (for unittests because of symbol visibility)
  add_library(nghttp3_static STATIC ${nghttp3_SOURCES})
  set_target_properties(nghttp3_static PROPERTIES
    COMPILE_FLAGS "${WARNCFLAGS}"
    VERSION ${LT_VERSION} SOVERSION ${LT_SOVERSION}
    ARCHIVE_OUTPUT_NAME nghttp3${STATIC_LIB_SUFFIX}
  )
  target_compile_definitions(nghttp3_static PUBLIC "-DNGHTTP3_STATICLIB")
  if(ENABLE_STATIC_LIB)
    install(TARGETS nghttp3_static
      DESTINATION "${CMAKE_INSTALL_LIBDIR}")
  endif()
endif()

install(TARGETS nghttp3
  DESTINATION "${CMAKE_INSTALL_LIBDIR}")

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libnghttp3.pc"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

=== debian/changelog ===
nghttp3 (0~20201019-1) sid; urgency=medium

  * Initial release (Closes: #934184)
    - using Draft-31 as upstream, commit 37c1c1b.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Sat, 28 Nov 2020 08:58:42 +0100

=== debian/control ===
Source: nghttp3
Priority: optional
Maintainer: Sakirnth Nagarasa <sakirnth@gmail.com>
Build-Depends:
 debhelper-compat (= 13),
 pkg-config,
Rules-Requires-Root: no
Standards-Version: 4.5.1
Section: libs
Homepage: https://github.com/ngtcp2/nghttp3
Vcs-Browser: https://salsa.debian.org/saki-guest/nghttp3
Vcs-Git: https://salsa.debian.org/saki-guest/nghttp3.git

Package: libnghttp3-0
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: HTTP/3 library with QUIC and QPACK (library)
 nghttp3 implements HTTP/3 functions in C. For now it supports several
 HTTP actions like request, response and server push.
 .
 This package contains the shared library.

Package: libnghttp3-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libnghttp3-0 (= ${binary:Version}),
 ${misc:Depends},
Description: HTTP/3 library with QUIC and QPACK (development)
 nghttp3 implements HTTP/3 functions in C. For now it supports several
 HTTP actions like request, response and server push.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_install:
	dh_install
	rm -f debian/tmp/usr/lib/*/*.la

## nghttp3 0.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,12 +25,12 @@
 
 cmake_minimum_required(VERSION 3.1)
 # XXX using 0.1.90 instead of 0.1.0-DEV
-project(nghttp3 VERSION 0.1.90)
+project(nghttp3 VERSION 0.1.1)
 
 # See versioning rule:
-#  http://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
+#  https://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
 set(LT_CURRENT  0)
-set(LT_REVISION 0)
+set(LT_REVISION 1)
 set(LT_AGE      0)
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
@@ -197,6 +197,15 @@
   endif()
 endif()
 
+if(ENABLE_STATIC_CRT)
+  foreach(lang C CXX)
+    foreach(suffix "" _DEBUG _MINSIZEREL _RELEASE _RELWITHDEBINFO)
+      set(var "CMAKE_${lang}_FLAGS${suffix}")
+      string(REPLACE "/MD" "/MT" ${var} "${${var}}")
+    endforeach()
+  endforeach()
+endif()
+
 if(ENABLE_DEBUG)
   set(DEBUGBUILD 1)
 endif()
@@ -260,6 +269,9 @@
       CXXFLAGS:       ${CMAKE_CXX_FLAGS_${_build_type}} ${CMAKE_CXX_FLAGS}
       WARNCFLAGS:     ${WARNCFLAGS}
       WARNCXXFLAGS:   ${WARNCXXFLAGS}
+    Library:
+      Shared:         ${ENABLE_SHARED_LIB}
+      Static:         ${ENABLE_STATIC_LIB}
     Test:
       CUnit:          ${HAVE_CUNIT} (LIBS='${CUNIT_LIBRARIES}')
     Library only:     ${ENABLE_LIB_ONLY}

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -59,12 +59,19 @@
 )
 
 # Public shared library
-add_library(nghttp3 SHARED ${nghttp3_SOURCES})
-set_target_properties(nghttp3 PROPERTIES
-  COMPILE_FLAGS "${WARNCFLAGS}"
-  VERSION ${LT_VERSION} SOVERSION ${LT_SOVERSION}
-  C_VISIBILITY_PRESET hidden
-)
+if(ENABLE_SHARED_LIB)
+  add_library(nghttp3 SHARED ${nghttp3_SOURCES})
+  set_target_properties(nghttp3 PROPERTIES
+    COMPILE_FLAGS "${WARNCFLAGS}"
+    VERSION ${LT_VERSION} SOVERSION ${LT_SOVERSION}
+    C_VISIBILITY_PRESET hidden
+  )
+
+  install(TARGETS nghttp3
+    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
+    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
+    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
+endif()
 
 if(HAVE_CUNIT OR ENABLE_STATIC_LIB)
   # Static library (for unittests because of symbol visibility)
@@ -81,8 +88,6 @@
   endif()
 endif()
 
-install(TARGETS nghttp3
-  DESTINATION "${CMAKE_INSTALL_LIBDIR}")
 
 install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libnghttp3.pc"
   DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

=== tests/CMakeLists.txt ===
# nghttp3
#
# Copyright (c) 2019 nghttp3 contributors
# Copyright (c) 2016 ngtcp2 contributors
# Copyright (c) 2012 nghttp2 contributors
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

if(HAVE_CUNIT)
  include_directories(
    "${CMAKE_SOURCE_DIR}/lib"
    "${CMAKE_SOURCE_DIR}/lib/includes"
    "${CMAKE_BINARY_DIR}/lib/includes"
    ${CUNIT_INCLUDE_DIRS}
  )

  set(main_SOURCES
    main.c
    nghttp3_qpack_test.c
    nghttp3_conn_test.c
    nghttp3_tnode_test.c
    nghttp3_http_test.c
    nghttp3_conv_test.c
    nghttp3_test_helper.c
  )

  add_executable(main EXCLUDE_FROM_ALL
    ${main_SOURCES}
  )
  target_include_directories(main PRIVATE ${CUNIT_INCLUDE_DIRS})
  # FIXME enable and fix warnings
  #set_target_properties(main PROPERTIES COMPILE_FLAGS "${WARNCFLAGS}")
  target_link_libraries(main
    nghttp3_static
    ${CUNIT_LIBRARIES}
    m
  )
  add_test(main main)
  add_dependencies(check main)
endif()

=== lib/includes/CMakeLists.txt ===
install(FILES
    nghttp3/nghttp3.h
    "${CMAKE_CURRENT_BINARY_DIR}/nghttp3/version.h"
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/nghttp3")

=== debian/changelog ===
nghttp3 (0.1.1-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 0.1.1.
  * d/copyright: Correcting copyright year for nghttp3 contributors.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Mon, 07 Feb 2022 20:45:09 +0100

nghttp3 (0~20210817-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 0~20210817.
  * Using execute_after_dh_install instead of override_dh_install.
  * Changing VCS path in debian/control.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Sat, 04 Sep 2021 09:15:06 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,15 @@
 Source: nghttp3
+Section: libs
 Priority: optional
 Maintainer: Sakirnth Nagarasa <sakirnth@gmail.com>
 Build-Depends:
  debhelper-compat (= 13),
  pkg-config,
 Rules-Requires-Root: no
-Standards-Version: 4.5.1
-Section: libs
+Standards-Version: 4.6.0
 Homepage: https://github.com/ngtcp2/nghttp3
-Vcs-Browser: https://salsa.debian.org/saki-guest/nghttp3
-Vcs-Git: https://salsa.debian.org/saki-guest/nghttp3.git
+Vcs-Browser: https://salsa.debian.org/saki/nghttp3
+Vcs-Git: https://salsa.debian.org/saki/nghttp3.git
 
 Package: libnghttp3-0
 Section: libs

## nghttp3 0.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,13 +24,13 @@
 # WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 
 cmake_minimum_required(VERSION 3.1)
-# XXX using 0.1.90 instead of 0.1.0-DEV
-project(nghttp3 VERSION 0.1.1)
+# XXX using 0.1.90 instead of 0.2.0-DEV
+project(nghttp3 VERSION 0.2.0)
 
 # See versioning rule:
 #  https://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
-set(LT_CURRENT  0)
-set(LT_REVISION 1)
+set(LT_CURRENT  1)
+set(LT_REVISION 0)
 set(LT_AGE      0)
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

=== debian/changelog ===
nghttp3 (0.2.0-3) sid; urgency=medium

  * Add d/libnghttp3-1.symbols file.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Tue, 21 Jun 2022 13:18:22 +0200

nghttp3 (0.2.0-2) sid; urgency=medium

  * Uploading to sid.
  * d/control: Updating Standards-Version.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Mon, 16 May 2022 10:59:25 +0200

nghttp3 (0.2.0-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 0.2.0.
  * d/control:
    - Updating binary package name because of soname bump.
    - Updating Depends because of soname bump.
  * Renaming debian/libnghttp3-0 to debian/libnghttp3-1.
  * d/copyright: Updating copyright for this version.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Mon, 28 Mar 2022 11:39:22 +0200

=== debian/control ===
--- 
+++ 
@@ -6,12 +6,12 @@
  debhelper-compat (= 13),
  pkg-config,
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/ngtcp2/nghttp3
 Vcs-Browser: https://salsa.debian.org/saki/nghttp3
 Vcs-Git: https://salsa.debian.org/saki/nghttp3.git
 
-Package: libnghttp3-0
+Package: libnghttp3-1
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -29,7 +29,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libnghttp3-0 (= ${binary:Version}),
+ libnghttp3-1 (= ${binary:Version}),
  ${misc:Depends},
 Description: HTTP/3 library with QUIC and QPACK (development)
  nghttp3 implements HTTP/3 functions in C. For now it supports several

## nghttp3 0.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,11 +25,11 @@
 
 cmake_minimum_required(VERSION 3.1)
 # XXX using 0.1.90 instead of 0.2.0-DEV
-project(nghttp3 VERSION 0.2.0)
+project(nghttp3 VERSION 0.7.0)
 
 # See versioning rule:
 #  https://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
-set(LT_CURRENT  1)
+set(LT_CURRENT  3)
 set(LT_REVISION 0)
 set(LT_AGE      0)
 
@@ -59,7 +59,7 @@
 foreach(_build_type "Release" "MinSizeRel" "RelWithDebInfo")
   foreach(_lang C CXX)
     string(TOUPPER "CMAKE_${_lang}_FLAGS_${_build_type}" _var)
-    string(REGEX REPLACE "(^| )[/-]D *NDEBUG($| )" "" ${_var} "${${_var}}")
+    string(REGEX REPLACE "(^| )[/-]D *NDEBUG($| )" " " ${_var} "${${_var}}")
   endforeach()
 endforeach()

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -56,6 +56,9 @@
   nghttp3_range.c
   nghttp3_http.c
   nghttp3_version.c
+  nghttp3_balloc.c
+  nghttp3_opl.c
+  nghttp3_objalloc.c
 )
 
 # Public shared library

=== debian/changelog ===
nghttp3 (0.7.0-2) sid; urgency=medium

  * Uploading to sid.
  * Source-only upload to allow testing migration.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Wed, 14 Sep 2022 19:00:04 +0200

nghttp3 (0.7.0-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 0.7.0.
  * d/control:
    - Updated binary package names because of soname bump.
    - Updated depends because of soname bump.
  * Removed d/libnghttp3-1.symbols.
  * Renamed d/libnghttp3-1.install to d/libnghttp3-3.install.
  * Added d/libnghttp3-3.symbols.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Sat, 27 Aug 2022 20:16:56 +0200

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Vcs-Browser: https://salsa.debian.org/saki/nghttp3
 Vcs-Git: https://salsa.debian.org/saki/nghttp3.git
 
-Package: libnghttp3-1
+Package: libnghttp3-3
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -29,7 +29,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libnghttp3-1 (= ${binary:Version}),
+ libnghttp3-3 (= ${binary:Version}),
  ${misc:Depends},
 Description: HTTP/3 library with QUIC and QPACK (development)
  nghttp3 implements HTTP/3 functions in C. For now it supports several

## nghttp3 0.8.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,12 +25,12 @@
 
 cmake_minimum_required(VERSION 3.1)
 # XXX using 0.1.90 instead of 0.2.0-DEV
-project(nghttp3 VERSION 0.7.0)
+project(nghttp3 VERSION 0.8.0)
 
 # See versioning rule:
 #  https://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
 set(LT_CURRENT  3)
-set(LT_REVISION 0)
+set(LT_REVISION 2)
 set(LT_AGE      0)
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

=== examples/CMakeLists.txt ===
# ngtcp3
#
# Copyright (c) 2019 nghttp3 contributors
# Copyright (c) 2017 ngtcp2 contributors
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

if(ENABLE_EXAMPLES)
  include_directories(
    ${CMAKE_SOURCE_DIR}/lib/includes
    ${CMAKE_BINARY_DIR}/lib/includes
  )

  link_libraries(
    nghttp3
  )

  set(qpack_SOURCES
    qpack.cc
    qpack_encode.cc
    qpack_decode.cc
    util.cc
  )

  add_executable(qpack ${qpack_SOURCES})
  set_target_properties(qpack PROPERTIES
    COMPILE_FLAGS "${WARNCXXFLAGS}"
    CXX_STANDARD 17
    CXX_STANDARD_REQUIRED ON
  )

  # TODO prevent qpack example from being installed?
endif()

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -59,6 +59,7 @@
   nghttp3_balloc.c
   nghttp3_opl.c
   nghttp3_objalloc.c
+  nghttp3_unreachable.c
 )
 
 # Public shared library

=== debian/changelog ===
nghttp3 (0.8.0-2~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux 21.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 14 Oct 2024 12:20:02 -0700

nghttp3 (0.8.0-2) sid; urgency=medium

  * Uploading to sid.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Fri, 06 Jan 2023 20:23:57 +0100

nghttp3 (0.8.0-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 0.8.0.
  * d/control: Updating Standards-Version.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Sun, 01 Jan 2023 20:05:12 +0100

=== debian/control ===
Source: nghttp3
Section: libs
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Sakirnth Nagarasa <sakirnth@gmail.com>
Build-Depends: debhelper-compat (= 13), pkg-config
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://github.com/ngtcp2/nghttp3
Vcs-Browser: https://salsa.debian.org/saki/nghttp3
Vcs-Git: https://salsa.debian.org/saki/nghttp3.git

Package: libnghttp3-3
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: HTTP/3 library with QUIC and QPACK (library)
 nghttp3 implements HTTP/3 functions in C. For now it supports several
 HTTP actions like request, response and server push.
 .
 This package contains the shared library.

Package: libnghttp3-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libnghttp3-3 (= ${binary:Version}), ${misc:Depends}
Description: HTTP/3 library with QUIC and QPACK (development)
 nghttp3 implements HTTP/3 functions in C. For now it supports several
 HTTP actions like request, response and server push.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

execute_after_dh_install:
	rm -f debian/tmp/usr/lib/*/*.la

	# Delete doc for now
	rm -rf debian/tmp/usr/share/doc/nghttp3

# No dbgsym packages:
override_dh_strip:
	@echo "not building dbgsym packages for MX Linux"
	dh_strip --no-automatic-dbgsym

## nghttp3 1.3.0

=== debian/changelog ===
nghttp3 (1.3.0-2) sid; urgency=medium

  * Uploading to sid (Closes: #1070079).

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Fri, 28 Jun 2024 16:55:48 +0200

nghttp3 (1.3.0-1) experimental; urgency=medium

  * New upstream version 1.3.0.
  * d/control: Changing Uploaders to folded field.
  * d/copyright: Correcting years and license.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Fri, 10 May 2024 15:27:56 +0200

nghttp3 (1.2.0-1) experimental; urgency=medium

  * New upstream version 1.2.0.
  * d/control:
    - Change build-depends from pkg-config to pkgconf.
    - Add Debian Curl Maintainers as Maintainer.
  * d/libnghttp3-9.symbols: Added symbol for version 1.2.0.
  * d/copyright: Updated for new version.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Wed, 08 May 2024 16:12:09 +0200

nghttp3 (1.1.0-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 1.1.0.
  * d/libnghttp3-9.symbols: Added symbol for version 1.1.0.
  * d/copyright: Updating authors and update year for d/*.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Mon, 08 Jan 2024 15:03:35 +0100

nghttp3 (0.15.0-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 0.15.0.
  * d/control:
    - Updated binary package names because of soname bump.
    - Updated depends because of soname bump.
  * Removed d/libnghttp3-3.symbols.
  * Renamed d/libnghttp3-3.install to d/libnghttp3-9.install.
  * Added d/libnghttp3-9.symbols.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Wed, 06 Sep 2023 14:50:41 +0200

## nghttp3 1.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -23,15 +23,15 @@
 # OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 # WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.20)
 # XXX using 0.1.90 instead of 0.2.0-DEV
-project(nghttp3 VERSION 0.8.0)
+project(nghttp3 VERSION 1.4.0)
 
 # See versioning rule:
 #  https://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
-set(LT_CURRENT  3)
+set(LT_CURRENT  11)
 set(LT_REVISION 2)
-set(LT_AGE      0)
+set(LT_AGE      2)
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 include(Version)
@@ -52,6 +52,7 @@
 endif()
 
 include(GNUInstallDirs)
+include(CMakeDependentOption)
 
 include(CMakeOptions.txt)
 
@@ -63,20 +64,12 @@
   endforeach()
 endforeach()
 
-find_package(CUnit 2.1)
 enable_testing()
-set(HAVE_CUNIT      ${CUNIT_FOUND})
-if(HAVE_CUNIT)
-  add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
-endif()
+add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
 
 # Checks for header files.
 include(CheckIncludeFile)
 check_include_file("arpa/inet.h"   HAVE_ARPA_INET_H)
-check_include_file("stddef.h"      HAVE_STDDEF_H)
-check_include_file("stdint.h"      HAVE_STDINT_H)
-check_include_file("stdlib.h"      HAVE_STDLIB_H)
-check_include_file("string.h"      HAVE_STRING_H)
 check_include_file("unistd.h"      HAVE_UNISTD_H)
 check_include_file("sys/endian.h"  HAVE_SYS_ENDIAN_H)
 check_include_file("endian.h"      HAVE_ENDIAN_H)
@@ -103,7 +96,10 @@
 
 check_symbol_exists(bswap_64 "byteswap.h" HAVE_BSWAP_64)
 
-include(ExtractValidFlags)
+if(${CMAKE_C_BYTE_ORDER} STREQUAL "BIG_ENDIAN")
+  set(WORDS_BIGENDIAN 1)
+endif()
+
 set(WARNCFLAGS)
 set(WARNCXXFLAGS)
 if(CMAKE_C_COMPILER_ID MATCHES "MSVC")
@@ -113,76 +109,16 @@
   endif()
 else()
   if(ENABLE_WERROR)
-    extract_valid_c_flags(WARNCFLAGS    -Werror)
-    extract_valid_c_flags(WARNCXXFLAGS  -Werror)
+    set(WARNCFLAGS   "-Werror")
+    set(WARNCXXFLAGS "-Werror")
   endif()
 
-  # For C compiler
-  extract_valid_c_flags(WARNCFLAGS
-    -Wall
-    -Wextra
-    -Wmissing-prototypes
-    -Wstrict-prototypes
-    -Wmissing-declarations
-    -Wpointer-arith
-    -Wdeclaration-after-statement
-    -Wformat-security
-    -Wwrite-strings
-    -Wshadow
-    -Winline
-    -Wnested-externs
-    -Wfloat-equal
-    -Wundef
-    -Wendif-labels
-    -Wempty-body
-    -Wcast-align
-    -Wclobbered
-    -Wvla
-    -Wpragmas
-    -Wunreachable-code
-    -Waddress
-    -Wattributes
-    -Wdiv-by-zero
-    -Wshorten-64-to-32
-
-    -Wconversion
-    -Wextended-offsetof
-    -Wformat-nonliteral
-    -Wlanguage-extension-token
-    -Wmissing-field-initializers
-    -Wmissing-noreturn
-    -Wmissing-variable-declarations
-    # Not used because we cannot change public structs
-    # -Wpadded
-    -Wsign-conversion
-    # Not used because this basically disallows default case
-    # -Wswitch-enum
-    -Wunreachable-code-break
-    -Wunused-macros
-    -Wunused-parameter
-    -Wredundant-decls
-    # Only work with Clang for the moment
-    -Wheader-guard
-    -Wsometimes-uninitialized
-
-    # Only work with gcc7 for the moment
-    -Wduplicated-branches
-    # This is required because we pass format string as "const char*.
-    -Wno-format-nonliteral
-  )
-
-  extract_valid_cxx_flags(WARNCXXFLAGS
-    # For C++ compiler
-    -Wall
-    -Wformat-security
-    -Wsometimes-uninitialized
-    # Disable noexcept-type warning of g++-7.  This is not harmful as
-    # long as all source files are compiled with the same compiler.
-    -Wno-noexcept-type
-  )
+  include(cmake/PickyWarningsC.cmake)
+  include(cmake/PickyWarningsCXX.cmake)
 
   if(ENABLE_ASAN)
     include(CMakePushCheckState)
+    include(CheckCCompilerFlag)
     cmake_push_check_state()
     set(CMAKE_REQUIRED_LIBRARIES "-fsanitize=address")
     check_c_compiler_flag(-fsanitize=address C__fsanitize_address_VALID)
@@ -241,6 +177,10 @@
   configure_file("${name}.in" "${name}" @ONLY)
 endforeach()
 
+if(ENABLE_SHARED_LIB AND ENABLE_STATIC_LIB AND MSVC AND NOT STATIC_LIB_SUFFIX)
+  set(STATIC_LIB_SUFFIX "_static")
+endif()
+
 include_directories(
   "${CMAKE_CURRENT_BINARY_DIR}" # for config.h
 )
@@ -250,7 +190,9 @@
 install(FILES README.rst DESTINATION "${CMAKE_INSTALL_DOCDIR}")
 
 add_subdirectory(lib)
-add_subdirectory(tests)
+if(BUILD_TESTING)
+  add_subdirectory(tests)
+endif()
 add_subdirectory(examples)
 
 
@@ -273,7 +215,7 @@
       Shared:         ${ENABLE_SHARED_LIB}
       Static:         ${ENABLE_STATIC_LIB}
     Test:
-      CUnit:          ${HAVE_CUNIT} (LIBS='${CUNIT_LIBRARIES}')
+      Build Test:     ${BUILD_TESTING}
     Library only:     ${ENABLE_LIB_ONLY}
     Examples:         ${ENABLE_EXAMPLES}
 ")

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -60,7 +60,32 @@
   nghttp3_opl.c
   nghttp3_objalloc.c
   nghttp3_unreachable.c
+  sfparse/sfparse.c
 )
+
+set(NGHTTP3_GENERATED_DIR "${CMAKE_CURRENT_BINARY_DIR}/generated")
+set(NGHTTP3_VERSION_CONFIG "${NGHTTP3_GENERATED_DIR}/${PROJECT_NAME}ConfigVersion.cmake")
+set(NGHTTP3_PROJECT_CONFIG "${NGHTTP3_GENERATED_DIR}/${PROJECT_NAME}Config.cmake")
+set(NGHTTP3_TARGETS_EXPORT_NAME "${PROJECT_NAME}Targets")
+set(NGHTTP3_CONFIG_INSTALL_DIR "lib/cmake/${PROJECT_NAME}")
+set(NGHTTP3_NAMESPACE "${PROJECT_NAME}::")
+set(NGHTTP3_VERSION ${PROJECT_VERSION})
+  
+include(CMakePackageConfigHelpers)
+write_basic_package_version_file(
+  "${NGHTTP3_VERSION_CONFIG}" VERSION ${NGHTTP3_VERSION} COMPATIBILITY SameMajorVersion
+)
+configure_file("${CMAKE_CURRENT_SOURCE_DIR}/config.cmake.in" "${NGHTTP3_PROJECT_CONFIG}" @ONLY)
+
+# Install cmake config files
+install(
+  FILES "${NGHTTP3_PROJECT_CONFIG}" "${NGHTTP3_VERSION_CONFIG}"
+  DESTINATION "${NGHTTP3_CONFIG_INSTALL_DIR}")
+
+install(
+  EXPORT "${NGHTTP3_TARGETS_EXPORT_NAME}"
+  NAMESPACE "${NGHTTP3_NAMESPACE}"
+  DESTINATION "${NGHTTP3_CONFIG_INSTALL_DIR}")
 
 # Public shared library
 if(ENABLE_SHARED_LIB)
@@ -72,26 +97,26 @@
   )
 
   install(TARGETS nghttp3
+    EXPORT ${NGHTTP3_TARGETS_EXPORT_NAME} 
     ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
     LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
     RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
 endif()
 
-if(HAVE_CUNIT OR ENABLE_STATIC_LIB)
-  # Static library (for unittests because of symbol visibility)
+if(ENABLE_STATIC_LIB)
+  # Public static library
   add_library(nghttp3_static STATIC ${nghttp3_SOURCES})
   set_target_properties(nghttp3_static PROPERTIES
     COMPILE_FLAGS "${WARNCFLAGS}"
     VERSION ${LT_VERSION} SOVERSION ${LT_SOVERSION}
     ARCHIVE_OUTPUT_NAME nghttp3${STATIC_LIB_SUFFIX}
-  )
+    )
   target_compile_definitions(nghttp3_static PUBLIC "-DNGHTTP3_STATICLIB")
-  if(ENABLE_STATIC_LIB)
-    install(TARGETS nghttp3_static
-      DESTINATION "${CMAKE_INSTALL_LIBDIR}")
-  endif()
+
+  install(TARGETS nghttp3_static
+    EXPORT ${NGHTTP3_TARGETS_EXPORT_NAME} 
+    DESTINATION "${CMAKE_INSTALL_LIBDIR}")
 endif()
-
 
 install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libnghttp3.pc"
   DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

=== debian/changelog ===
nghttp3 (1.4.0-1~bpo12+1) bookworm-backports; urgency=medium

  * Team upload.
  * Rebuild for bookworm-backports.

 -- Samuel Henrique <samueloph@debian.org>  Sun, 11 Aug 2024 12:27:12 +0100

nghttp3 (1.4.0-1) sid; urgency=medium

  * New upstream version 1.4.0.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Wed, 24 Jul 2024 03:45:14 +0200

## nghttp3 1.6.0

=== debian/changelog ===
nghttp3 (1.6.0-2~bpo12+1) bookworm-backports; urgency=medium

  * Team upload.
  * Rebuild for bookworm-backports.

 -- Matheus Polkorny <mpolkorny@gmail.com>  Mon, 02 Dec 2024 21:13:10 -0300

nghttp3 (1.6.0-2) unstable; urgency=medium

  * d/changelog: Remove 1.4.0-1~bpo12+1 entry from unstable changelog.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Thu, 28 Nov 2024 08:28:57 +0100

nghttp3 (1.6.0-1) unstable; urgency=medium

  * New upstream version 1.6.0.
  * d/changelog: Changing naming sid to unstable.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Wed, 13 Nov 2024 15:47:55 +0100

nghttp3 (1.4.0-1) unstable; urgency=medium

  * New upstream version 1.4.0.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Wed, 24 Jul 2024 03:45:14 +0200

nghttp3 (1.3.0-2) unstable; urgency=medium

  * Uploading to unstable (Closes: #1070079).

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Fri, 28 Jun 2024 16:55:48 +0200

nghttp3 (0.8.0-2) unstable; urgency=medium

  * Uploading to unstable.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Fri, 06 Jan 2023 20:23:57 +0100

nghttp3 (0.7.0-2) unstable; urgency=medium

  * Uploading to unstable.
  * Source-only upload to allow testing migration.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Wed, 14 Sep 2022 19:00:04 +0200

nghttp3 (0.2.0-3) unstable; urgency=medium

  * Add d/libnghttp3-1.symbols file.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Tue, 21 Jun 2022 13:18:22 +0200

nghttp3 (0.2.0-2) unstable; urgency=medium

  * Uploading to unstable.
  * d/control: Updating Standards-Version.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Mon, 16 May 2022 10:59:25 +0200

nghttp3 (0.1.1-1) unstable; urgency=medium

  * Uploading to unstable.
  * Merging upstream version 0.1.1.
  * d/copyright: Correcting copyright year for nghttp3 contributors.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Mon, 07 Feb 2022 20:45:09 +0100

nghttp3 (0~20210817-1) unstable; urgency=medium

  * Uploading to unstable.
  * Merging upstream version 0~20210817.
  * Using execute_after_dh_install instead of override_dh_install.
  * Changing VCS path in debian/control.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Sat, 04 Sep 2021 09:15:06 +0200

nghttp3 (0~20201019-1) unstable; urgency=medium

  * Initial release (Closes: #934184).
    - using Draft-31 as upstream, commit 37c1c1b.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Sat, 28 Nov 2020 08:58:42 +0100

=== debian/control ===
Source: nghttp3
Section: libs
Priority: optional
Maintainer: Debian Curl Maintainers <team+curl@tracker.debian.org>
Uploaders:
 Sakirnth Nagarasa <sakirnth@gmail.com>,
Build-Depends:
 debhelper-compat (= 13),
 pkgconf,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://github.com/ngtcp2/nghttp3
Vcs-Browser: https://salsa.debian.org/saki/nghttp3
Vcs-Git: https://salsa.debian.org/saki/nghttp3.git

Package: libnghttp3-9
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: HTTP/3 library with QUIC and QPACK (library)
 nghttp3 implements HTTP/3 functions in C. For now it supports several
 HTTP actions like request, response and server push.
 .
 This package contains the shared library.

Package: libnghttp3-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libnghttp3-9 (= ${binary:Version}),
 ${misc:Depends},
Description: HTTP/3 library with QUIC and QPACK (development)
 nghttp3 implements HTTP/3 functions in C. For now it supports several
 HTTP actions like request, response and server push.
 .
 This package contains the development files.

## nghttp3 1.8.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,12 +25,12 @@
 
 cmake_minimum_required(VERSION 3.20)
 # XXX using 0.1.90 instead of 0.2.0-DEV
-project(nghttp3 VERSION 1.4.0)
+project(nghttp3 VERSION 1.8.0)
 
 # See versioning rule:
 #  https://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
 set(LT_CURRENT  11)
-set(LT_REVISION 2)
+set(LT_REVISION 6)
 set(LT_AGE      2)
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
@@ -88,13 +88,13 @@
 # Checks for symbols.
 include(CheckSymbolExists)
 if(HAVE_ENDIAN_H)
-  check_symbol_exists(be64toh "endian.h" HAVE_BE64TOH)
-endif()
-if(HAVE_SYS_ENDIAN_H)
-  check_symbol_exists(be64toh "sys/endian.h" HAVE_BE64TOH)
-endif()
-
-check_symbol_exists(bswap_64 "byteswap.h" HAVE_BSWAP_64)
+  check_symbol_exists(be64toh "endian.h" HAVE_DECL_BE64TOH)
+endif()
+if(NOT HAVE_DECL_BE64TOH AND HAVE_SYS_ENDIAN_H)
+  check_symbol_exists(be64toh "sys/endian.h" HAVE_DECL_BE64TOH)
+endif()
+
+check_symbol_exists(bswap_64 "byteswap.h" HAVE_DECL_BSWAP_64)
 
 if(${CMAKE_C_BYTE_ORDER} STREQUAL "BIG_ENDIAN")
   set(WORDS_BIGENDIAN 1)
@@ -103,6 +103,13 @@
 set(WARNCFLAGS)
 set(WARNCXXFLAGS)
 if(CMAKE_C_COMPILER_ID MATCHES "MSVC")
+  if(CMAKE_C_COMPILER_ARCHITECTURE_ID MATCHES "x64")
+    set(CMAKE_C_FLAGS "/guard:ehcont ${CMAKE_C_FLAGS}")
+  endif()
+  if(CMAKE_CXX_COMPILER_ARCHITECTURE_ID MATCHES "x64")
+    set(CMAKE_CXX_FLAGS "/guard:ehcont ${CMAKE_CXX_FLAGS}")
+  endif()
+
   if(ENABLE_WERROR)
     set(WARNCFLAGS    /WX)
     set(WARNCXXFLAGS  /WX)
@@ -134,12 +141,7 @@
 endif()
 
 if(ENABLE_STATIC_CRT)
-  foreach(lang C CXX)
-    foreach(suffix "" _DEBUG _MINSIZEREL _RELEASE _RELWITHDEBINFO)
-      set(var "CMAKE_${lang}_FLAGS${suffix}")
-      string(REPLACE "/MD" "/MT" ${var} "${${var}}")
-    endforeach()
-  endforeach()
+  set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
 endif()
 
 if(ENABLE_DEBUG)

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -70,7 +70,7 @@
 set(NGHTTP3_CONFIG_INSTALL_DIR "lib/cmake/${PROJECT_NAME}")
 set(NGHTTP3_NAMESPACE "${PROJECT_NAME}::")
 set(NGHTTP3_VERSION ${PROJECT_VERSION})
-  
+
 include(CMakePackageConfigHelpers)
 write_basic_package_version_file(
   "${NGHTTP3_VERSION_CONFIG}" VERSION ${NGHTTP3_VERSION} COMPATIBILITY SameMajorVersion
@@ -82,11 +82,6 @@
   FILES "${NGHTTP3_PROJECT_CONFIG}" "${NGHTTP3_VERSION_CONFIG}"
   DESTINATION "${NGHTTP3_CONFIG_INSTALL_DIR}")
 
-install(
-  EXPORT "${NGHTTP3_TARGETS_EXPORT_NAME}"
-  NAMESPACE "${NGHTTP3_NAMESPACE}"
-  DESTINATION "${NGHTTP3_CONFIG_INSTALL_DIR}")
-
 # Public shared library
 if(ENABLE_SHARED_LIB)
   add_library(nghttp3 SHARED ${nghttp3_SOURCES})
@@ -96,8 +91,10 @@
     C_VISIBILITY_PRESET hidden
   )
 
+  target_include_directories(nghttp3 INTERFACE $<INSTALL_INTERFACE:include>)
+
   install(TARGETS nghttp3
-    EXPORT ${NGHTTP3_TARGETS_EXPORT_NAME} 
+    EXPORT ${NGHTTP3_TARGETS_EXPORT_NAME}
     ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
     LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
     RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
@@ -111,12 +108,20 @@
     VERSION ${LT_VERSION} SOVERSION ${LT_SOVERSION}
     ARCHIVE_OUTPUT_NAME nghttp3${STATIC_LIB_SUFFIX}
     )
+
+  target_include_directories(nghttp3_static INTERFACE $<INSTALL_INTERFACE:include>)
+
   target_compile_definitions(nghttp3_static PUBLIC "-DNGHTTP3_STATICLIB")
 
   install(TARGETS nghttp3_static
-    EXPORT ${NGHTTP3_TARGETS_EXPORT_NAME} 
+    EXPORT ${NGHTTP3_TARGETS_EXPORT_NAME}
     DESTINATION "${CMAKE_INSTALL_LIBDIR}")
 endif()
 
+install(
+  EXPORT "${NGHTTP3_TARGETS_EXPORT_NAME}"
+  NAMESPACE "${NGHTTP3_NAMESPACE}"
+  DESTINATION "${NGHTTP3_CONFIG_INSTALL_DIR}")
+
 install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libnghttp3.pc"
   DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

=== debian/changelog ===
nghttp3 (1.8.0-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 15 Mar 2025 18:05:58 -0700

nghttp3 (1.8.0-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Samuel Henrique <samueloph@debian.org>  Fri, 07 Mar 2025 22:26:29 +0000

nghttp3 (1.8.0-1) unstable; urgency=medium

  [ Matheus Polkorny ]
  * d/watch: Add debian/watch file with signature verification.
  * d/upstream/signing-key.asc: Upstream public key.

  [ Sakirnth Nagarasa ]
  * New upstream version 1.8.0.
  * d/gbp.conf: Adding debian/unstable as default branch.
  * d/copyright: Updating years and author for debian/*.
  * d/control:
    - Updating Standards-Version.
    - Updating Vsc path.

 -- Sakirnth Nagarasa <sakirnth@gmail.com>  Sat, 01 Mar 2025 10:38:20 +0100

=== debian/control ===
Source: nghttp3
Section: libs
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Curl Maintainers <team+curl@tracker.debian.org>
Uploaders: Sakirnth Nagarasa <sakirnth@gmail.com>
Build-Depends: debhelper-compat (= 13), pkgconf
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: https://github.com/ngtcp2/nghttp3
Vcs-Browser: https://salsa.debian.org/debian/nghttp3
Vcs-Git: https://salsa.debian.org/debian/nghttp3.git

Package: libnghttp3-9
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: HTTP/3 library with QUIC and QPACK (library)
 nghttp3 implements HTTP/3 functions in C. For now it supports several
 HTTP actions like request, response and server push.
 .
 This package contains the shared library.

Package: libnghttp3-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libnghttp3-9 (= ${binary:Version}), ${misc:Depends}
Description: HTTP/3 library with QUIC and QPACK (development)
 nghttp3 implements HTTP/3 functions in C. For now it supports several
 HTTP actions like request, response and server push.
 .
 This package contains the development files.

=== debian/rules ===
--- 
+++ 
@@ -11,5 +11,5 @@
 
 # No dbgsym packages:
 override_dh_strip:
-	@echo "not building dbgsym packages for MX Linux"
+	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
 	dh_strip --no-automatic-dbgsym

## nghttp3 1.11.0

=== debian/changelog ===
nghttp3 (1.11.0-1~exp1) experimental; urgency=medium

  * Team upload
  * New upstream version 1.11.0

 -- Samuel Henrique <samueloph@debian.org>  Fri, 05 Sep 2025 19:04:09 +0100
